#property  indicator_chart_window
#property  indicator_buffers 2
#property  indicator_color1  Silver
#property  indicator_color2  MediumVioletRed

extern  int      MinBars  = 0;
extern  int      prPeriod = PERIOD_M1;


int      PreBars;
datetime BarTime;
int      StartPos;
int      pos;
string   mSymbol;

double   Kalman[], Prognoz[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
  mSymbol = Symbol();
  SetIndexBuffer(0,Kalman);
  SetIndexBuffer(1,Prognoz);
  SetIndexStyle(0,DRAW_LINE);
  SetIndexStyle(1,DRAW_LINE);
//----      
  SetIndexEmptyValue(0,0.0);
  SetIndexEmptyValue(1,0.0);
  SetIndexLabel(0,"Kalman");
  SetIndexLabel(1,"Prognoz");
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
  return(0);
}
//+------------------------------------------------------------------+
//|                                     |
//+------------------------------------------------------------------+
int Reset() {
  if (MinBars == 0) MinBars = iBars(mSymbol, prPeriod)-2;
  StartPos = MinBars;
  PreBars = 0;
  BarTime = 0;
// .......
  StartPos++;
  return(StartPos);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
double K_1=1, K_2=1;
//      
  if (iBars(mSymbol, prPeriod) == PreBars) return(0);  
//  ,     
  if (iBars(mSymbol, prPeriod) < MinBars) {
    Alert(":    ");
    return(0);
  }  
//      ,    
  if (iBars(mSymbol, prPeriod)-PreBars == 1 && BarTime==iTime(mSymbol, prPeriod,1)) StartPos = 1;
//       Reset()   
  else StartPos = Reset();
//   
  PreBars = iBars(mSymbol, prPeriod);  
  BarTime = iTime(mSymbol, prPeriod,0);
//   
  for (pos=StartPos;pos>0;pos--) {
//   .....
// ......
//  ()   
   Kalman[pos]=K_1*iClose(mSymbol, prPeriod,pos);      //   
//    
   Prognoz[pos-1]=K_2*Kalman[pos]; //   

  }  //  pos=StartPos;pos>0;pos--) 
  return(0);
}